Index: issm/trunk/src/c/classes/Elements/Tria.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Tria.h	(revision 18301)
@@ -53,6 +53,4 @@
 		void        ComputeBasalStress(Vector<IssmDouble>* sigma_b);
 		void        ComputeSigmaNN();
-		void		   ComputeStrainRate();
-		void		   ComputeStrainRate(Vector<IssmDouble>* eps){_error_("not implemented yet");};
 		void        ComputeStressTensor();
 		void        ComputeDeviatoricStressTensor();
@@ -60,4 +58,5 @@
 		void        Configure(Elements* elements,Loads* loads,Nodes* nodesin,Vertices* verticesin,Materials* materials,Parameters* parameters);
 		void        SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Materials* materials,Parameters* parameters);
+		void        ResetHooks();
 		void        Delta18oParameterization(void);
 		void        ElementSizes(IssmDouble* hx,IssmDouble* hy,IssmDouble* hz);
@@ -70,4 +69,5 @@
 		int         GetNodeIndex(Node* node);
 		int         GetNumberOfNodes(void);
+		int         GetNumberOfNodes(int enum_type);
 		int         GetNumberOfVertices(void);
 		bool        IsOnBase();
@@ -93,5 +93,4 @@
 		void        ReduceMatrices(ElementMatrix* Ke,ElementVector* pe);
 		void        ResetFSBasalBoundaryCondition(void);
-		void	      SmbGradients();
 	   Element*    SpawnBasalElement(void);
 		Element*    SpawnTopElement(void);
@@ -102,13 +101,14 @@
 		void        Update(int index, IoModel* iomodel,int analysis_counter,int analysis_type,int finitelement);
 		IssmDouble  TimeAdapt();
-		void   ValueP1OnGauss(IssmDouble* pvalue,IssmDouble* values,Gauss* gauss);
-		void   ValueP1DerivativesOnGauss(IssmDouble* dvalue,IssmDouble* values,IssmDouble* xyz_list,Gauss* gauss);
+		void        ValueP1OnGauss(IssmDouble* pvalue,IssmDouble* values,Gauss* gauss);
+		void        ValueP1DerivativesOnGauss(IssmDouble* dvalue,IssmDouble* values,IssmDouble* xyz_list,Gauss* gauss);
 		int         VertexConnectivity(int vertexindex);
-		void   VerticalSegmentIndices(int** pindices,int* pnumseg){_error_("not implemented yet");};
+		void        VerticalSegmentIndices(int** pindices,int* pnumseg){_error_("not implemented yet");};
 		void        ZeroLevelsetCoordinates(IssmDouble** pxyz_zero,IssmDouble* xyz_list,int levelsetenum);
-		void	    GetIcefrontCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum);
+		void	      GetIcefrontCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum);
+		void	      GetLevelCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum,IssmDouble level);
 		bool        IsZeroLevelset(int levelset_enum);
-		bool		IsIcefront(void);
-		bool		IsFaceOnBoundary(void);
+		bool	   	IsIcefront(void);
+		bool	   	IsFaceOnBoundary(void);
 
 		void       AverageOntoPartition(Vector<IssmDouble>* partition_contributions,Vector<IssmDouble>* partition_areas,IssmDouble* vertex_response,IssmDouble* qmu_part);
@@ -116,18 +116,7 @@
 		IssmDouble IceVolumeAboveFloatation(void);
 		IssmDouble TotalSmb(void);
-		void       MinVel(IssmDouble* pminvel);
-		void       MinVx(IssmDouble* pminvx);
-		void       MinVy(IssmDouble* pminvy);
-		void       MinVz(IssmDouble* pminvz);
 		IssmDouble MassFlux(IssmDouble* segment);
 		IssmDouble MassFlux(IssmDouble x1,IssmDouble y1, IssmDouble x2, IssmDouble y2,int segment_id);
-		void       MaxAbsVx(IssmDouble* pmaxabsvx);
-		void       MaxAbsVy(IssmDouble* pmaxabsvy);
-		void       MaxAbsVz(IssmDouble* pmaxabsvz);
 		void       ElementResponse(IssmDouble* presponse,int response_enum);
-		void       MaxVel(IssmDouble* pmaxvel);
-		void       MaxVx(IssmDouble* pmaxvx);
-		void       MaxVy(IssmDouble* pmaxvy);
-		void       MaxVz(IssmDouble* pmaxvz);
 		IssmDouble Misfit(int modelenum,int observationenum,int weightsenum);
 		IssmDouble MisfitArea(int weightsenum);
@@ -137,21 +126,6 @@
 		#endif
 
-		void       GradientIndexing(int* indexing,int control_index);
-		void       Gradj(Vector<IssmDouble>* gradient,int control_type,int control_index);
-		void       GradjBGradient(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjDGradient(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjBSSA(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjDSSA(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjDragSSA(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjDragFS(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjDragGradient(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjDhDtBalancedthickness(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjVxBalancedthickness(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjVyBalancedthickness(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjThicknessBalancethicknessSoft(Vector<IssmDouble>* gradient,int control_index);
 		void       GetVectorFromControlInputs(Vector<IssmDouble>* gradient,int control_enum,int control_index,const char* data);
 		void       SetControlInputsFromVector(IssmDouble* vector,int control_enum,int control_index);
-		void       ControlInputGetGradient(Vector<IssmDouble>* gradient,int enum_type,int control_index);
-		void       ControlInputScaleGradient(int enum_type,IssmDouble scale);
 		void       ControlInputSetGradient(IssmDouble* gradient,int enum_type,int control_index);
 		void       ControlToVectors(Vector<IssmPDouble>* vector_control, Vector<IssmPDouble>* vector_gradient,int control_enum);
@@ -192,7 +166,8 @@
 		Gauss*         NewGaussTop(int order);
 		void           NodalFunctions(IssmDouble* basis,Gauss* gauss);
-		void           NodalFunctionsP1(IssmDouble* basis,Gauss* gauss){_error_("not implemented yet");};
+		void           NodalFunctionsP1(IssmDouble* basis,Gauss* gauss);
+		void           NodalFunctionsP2(IssmDouble* basis,Gauss* gauss);
 		void           NodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss);
-		void           NodalFunctionsP1Derivatives(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss){_error_("not implemented yet");};
+		void           NodalFunctionsP1Derivatives(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss);
 		void           NodalFunctionsMINIDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss){_error_("not implemented yet");};
 		void           NodalFunctionsDerivativesVelocity(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss);
Index: issm/trunk/src/c/classes/Elements/TriaRef.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/TriaRef.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/TriaRef.cpp	(revision 18301)
@@ -4,5 +4,5 @@
 
 /*Headers:*/
-/*{{{*//*{{{*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -20,32 +20,16 @@
 #define NUMNODESP1b 4
 #define NUMNODESP2  6
+#define NUMNODESP2b 7
 
 /*Object constructors and destructor*/
 TriaRef::TriaRef(){/*{{{*/
-	this->element_type_list=NULL;
-}
-/*}}}*/
-TriaRef::TriaRef(const int nummodels){/*{{{*/
-
-	/*Only allocate pointer*/
-	element_type_list=xNew<int>(nummodels);
-
 }
 /*}}}*/
 TriaRef::~TriaRef(){/*{{{*/
-	xDelete<int>(element_type_list);
-}
-/*}}}*/
-
-/*Management*/
-void TriaRef::SetElementType(int type,int type_counter){/*{{{*/
-
-	/*initialize element type*/
-	this->element_type_list[type_counter]=type;
 }
 /*}}}*/
 
 /*Reference Element numerics*/
-void TriaRef::GetSegmentBFlux(IssmDouble* B,Gauss* gauss, int index1,int index2){/*{{{*/
+void TriaRef::GetSegmentBFlux(IssmDouble* B,Gauss* gauss, int index1,int index2,int finiteelement){/*{{{*/
 	/*Compute B  matrix. B=[phi1 phi2 -phi3 -phi4]
 	 *
@@ -56,9 +40,9 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(finiteelement);
 
 	/*Get nodal functions*/
 	IssmDouble* basis=xNew<IssmDouble>(numnodes);
-	GetNodalFunctions(basis,gauss);
+	GetNodalFunctions(basis,gauss,finiteelement);
 
 	/*Build B for this segment*/
@@ -72,5 +56,5 @@
 }
 /*}}}*/
-void TriaRef::GetSegmentBprimeFlux(IssmDouble* Bprime,Gauss* gauss, int index1,int index2){/*{{{*/
+void TriaRef::GetSegmentBprimeFlux(IssmDouble* Bprime,Gauss* gauss, int index1,int index2,int finiteelement){/*{{{*/
 	/*Compute Bprime  matrix. Bprime=[phi1 phi2 phi3 phi4]
 	 *
@@ -81,9 +65,9 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(finiteelement);
 
 	/*Get nodal functions*/
 	IssmDouble* basis=xNew<IssmDouble>(numnodes);
-	GetNodalFunctions(basis,gauss);
+	GetNodalFunctions(basis,gauss,finiteelement);
 
 	/*Build B'*/
@@ -155,12 +139,4 @@
 }
 /*}}}*/
-void TriaRef::GetNodalFunctions(IssmDouble* basis,Gauss* gauss){/*{{{*/
-	/*This routine returns the values of the nodal functions  at the gaussian point.*/
-
-	_assert_(basis);
-	GetNodalFunctions(basis,gauss,this->element_type);
-
-}
-/*}}}*/
 void TriaRef::GetNodalFunctions(IssmDouble* basis,Gauss* gauss_in,int finiteelement){/*{{{*/
 	/*This routine returns the values of the nodal functions  at the gaussian point.*/
@@ -173,4 +149,6 @@
 
 	switch(finiteelement){
+		case NoneEnum:
+			return;
 		case P0Enum:
 			basis[0]=1.;
@@ -199,4 +177,16 @@
 			basis[5]=4.*gauss->coord1*gauss->coord2;
 			return;
+		case P2bubbleEnum: case P2bubblecondensedEnum:
+			/*Corner nodes*/
+			basis[0]=gauss->coord1*(2.*gauss->coord1-1.);
+			basis[1]=gauss->coord2*(2.*gauss->coord2-1.);
+			basis[2]=gauss->coord3*(2.*gauss->coord3-1.);
+			/*Mid-sides*/
+			basis[3]=4.*gauss->coord3*gauss->coord2;
+			basis[4]=4.*gauss->coord3*gauss->coord1;
+			basis[5]=4.*gauss->coord1*gauss->coord2;
+			/*bubble*/
+			basis[6]=27.*gauss->coord1*gauss->coord2*gauss->coord3;
+			return;
 		default:
 			_error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
@@ -204,5 +194,5 @@
 }
 /*}}}*/
-void TriaRef::GetSegmentNodalFunctions(IssmDouble* basis,Gauss* gauss,int index1,int index2){/*{{{*/
+void TriaRef::GetSegmentNodalFunctions(IssmDouble* basis,Gauss* gauss,int index1,int index2,int finiteelement){/*{{{*/
 	/*This routine returns the values of the nodal functions  at the gaussian point.*/
 
@@ -211,11 +201,11 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(finiteelement);
 
 	/*Get nodal functions*/
 	IssmDouble* triabasis=xNew<IssmDouble>(numnodes);
-	GetNodalFunctions(triabasis,gauss);
-
-	switch(this->element_type){
+	GetNodalFunctions(triabasis,gauss,finiteelement);
+
+	switch(finiteelement){
 		case P1Enum: case P1DGEnum:
 			basis[0]=triabasis[index1];
@@ -236,15 +226,9 @@
 			return;
 		default:
-			_error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+			_error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
 	}
 
 	/*Clean up*/
 	xDelete<IssmDouble>(triabasis);
-}
-/*}}}*/
-void TriaRef::GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
-
-	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss,this->element_type);
-
 }
 /*}}}*/
@@ -276,12 +260,4 @@
 	/*Clean up*/
 	xDelete<IssmDouble>(dbasis_ref);
-
-}
-/*}}}*/
-void TriaRef::GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,Gauss* gauss){/*{{{*/
-	/*This routine returns the values of the nodal functions derivatives  (with respect to the 
-	 * natural coordinate system) at the gaussian point. */
-
-	GetNodalFunctionsDerivativesReference(dbasis,gauss,this->element_type);
 
 }
@@ -348,4 +324,27 @@
 			dbasis[NUMNODESP2*1+5] = -2.*SQRT3/3.*(gauss->coord1+gauss->coord2);
 			return;
+		case P2bubbleEnum: case P2bubblecondensedEnum:
+			/*Nodal function 1*/
+			dbasis[NUMNODESP2b*0+0] = -2.*gauss->coord1 + 0.5;
+			dbasis[NUMNODESP2b*1+0] = -2.*SQRT3/3.*gauss->coord1 + SQRT3/6.;
+			/*Nodal function 2*/
+			dbasis[NUMNODESP2b*0+1] = +2.*gauss->coord2 - 0.5;
+			dbasis[NUMNODESP2b*1+1] = -2.*SQRT3/3.*gauss->coord2 + SQRT3/6.;
+			/*Nodal function 3*/
+			dbasis[NUMNODESP2b*0+2] = 0.;
+			dbasis[NUMNODESP2b*1+2] = +4.*SQRT3/3.*gauss->coord3 - SQRT3/3.;
+			/*Nodal function 4*/
+			dbasis[NUMNODESP2b*0+3] = +2.*gauss->coord3;
+			dbasis[NUMNODESP2b*1+3] = +4.*SQRT3/3.*gauss->coord2 - 2.*SQRT3/3.*gauss->coord3;
+			/*Nodal function 5*/
+			dbasis[NUMNODESP2b*0+4] = -2.*gauss->coord3;
+			dbasis[NUMNODESP2b*1+4] = +4.*SQRT3/3.*gauss->coord1 - 2.*SQRT3/3.*gauss->coord3;
+			/*Nodal function 6*/
+			dbasis[NUMNODESP2b*0+5] = 2.*(gauss->coord1-gauss->coord2);
+			dbasis[NUMNODESP2b*1+5] = -2.*SQRT3/3.*(gauss->coord1+gauss->coord2);
+			/*Nodal function 7*/
+			dbasis[NUMNODESP2b*0+6] = 27.*(-.5*gauss->coord2*gauss->coord3 + .5*gauss->coord1*gauss->coord3);
+			dbasis[NUMNODESP2b*1+6] = 27.*SQRT3*(-1./6.*gauss->coord2*gauss->coord3 - 1./6.*gauss->coord1*gauss->coord3 +1./3.*gauss->coord1*gauss->coord2);
+			return;
 		default:
 			_error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
@@ -354,5 +353,5 @@
 }
 /*}}}*/
-void TriaRef::GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
+void TriaRef::GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, Gauss* gauss,int finiteelement){/*{{{*/
 
 	/*From node values of parameter p (plist[0],plist[1],plist[2]), return parameter derivative value at gaussian 
@@ -369,9 +368,9 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(finiteelement);
 
 	/*Get nodal functions derivatives*/
 	IssmDouble* dbasis=xNew<IssmDouble>(2*numnodes);
-	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss);
+	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss,finiteelement);
 
 	/*Calculate parameter for this Gauss point*/
@@ -386,9 +385,4 @@
 }
 /*}}}*/
-void TriaRef::GetInputValue(IssmDouble* p, IssmDouble* plist, Gauss* gauss){/*{{{*/
-
-	GetInputValue(p,plist,gauss,this->element_type);
-}
-/*}}}*/
 void TriaRef::GetInputValue(IssmDouble* p, IssmDouble* plist, Gauss* gauss,int finiteelement){/*{{{*/
 
@@ -411,12 +405,8 @@
 }
 /*}}}*/
-int  TriaRef::NumberofNodes(void){/*{{{*/
-
-	return this->NumberofNodes(this->element_type);
-}
-/*}}}*/
 int  TriaRef::NumberofNodes(int finiteelement){/*{{{*/
 
 	switch(finiteelement){
+		case NoneEnum:              return 0;
 		case P0Enum:                return NUMNODESP0;
 		case P1Enum:                return NUMNODESP1;
@@ -425,4 +415,6 @@
 		case P1bubblecondensedEnum: return NUMNODESP1b;
 		case P2Enum:                return NUMNODESP2;
+		case P2bubbleEnum:          return NUMNODESP2b;
+		case P2bubblecondensedEnum: return NUMNODESP2b;
 		case P1P1Enum:              return NUMNODESP1*2;
 		case P1P1GLSEnum:           return NUMNODESP1*2;
@@ -430,6 +422,8 @@
 		case MINIEnum:              return NUMNODESP1b+NUMNODESP1;
 		case TaylorHoodEnum:        return NUMNODESP2+NUMNODESP1;
+		case LATaylorHoodEnum:      return NUMNODESP2;
 		case XTaylorHoodEnum:       return NUMNODESP2+NUMNODESP1;
-		default: _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+		case CrouzeixRaviartEnum:   return NUMNODESP2b+NUMNODESP1;
+		default: _error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
 	}
 
@@ -437,14 +431,16 @@
 }
 /*}}}*/
-int  TriaRef::VelocityInterpolation(void){/*{{{*/
-
-	switch(this->element_type){
-		case P1P1Enum:          return P1Enum;
-		case P1P1GLSEnum:       return P1Enum;
-		case MINIcondensedEnum: return P1bubbleEnum;
-		case MINIEnum:          return P1bubbleEnum;
-		case TaylorHoodEnum:    return P2Enum;
-		case XTaylorHoodEnum:   return P2Enum;
-		default:       _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+int  TriaRef::VelocityInterpolation(int fe_stokes){/*{{{*/
+
+	switch(fe_stokes){
+		case P1P1Enum:           return P1Enum;
+		case P1P1GLSEnum:        return P1Enum;
+		case MINIcondensedEnum:  return P1bubbleEnum;
+		case MINIEnum:           return P1bubbleEnum;
+		case TaylorHoodEnum:     return P2Enum;
+		case LATaylorHoodEnum:   return P2Enum;
+		case XTaylorHoodEnum:    return P2Enum;
+		case CrouzeixRaviartEnum:return P2bubbleEnum;
+		default:       _error_("Element type "<<EnumToStringx(fe_stokes)<<" not supported yet");
 	}
 
@@ -452,14 +448,16 @@
 }
 /*}}}*/
-int  TriaRef::PressureInterpolation(void){/*{{{*/
-
-	switch(this->element_type){
-		case P1P1Enum:          return P1Enum;
-		case P1P1GLSEnum:       return P1Enum;
-		case MINIcondensedEnum: return P1Enum;
-		case MINIEnum:          return P1Enum;
-		case TaylorHoodEnum:    return P1Enum;
-		case XTaylorHoodEnum:   return P1Enum;
-		default:       _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+int  TriaRef::PressureInterpolation(int fe_stokes){/*{{{*/
+
+	switch(fe_stokes){
+		case P1P1Enum:            return P1Enum;
+		case P1P1GLSEnum:         return P1Enum;
+		case MINIcondensedEnum:   return P1Enum;
+		case MINIEnum:            return P1Enum;
+		case TaylorHoodEnum:      return P1Enum;
+		case LATaylorHoodEnum:    return NoneEnum;
+		case XTaylorHoodEnum:     return P1Enum;
+		case CrouzeixRaviartEnum: return P1DGEnum;
+		default:       _error_("Element type "<<EnumToStringx(fe_stokes)<<" not supported yet");
 	}
 
@@ -467,10 +465,10 @@
 }
 /*}}}*/
-int  TriaRef::TensorInterpolation(void){/*{{{*/
+int  TriaRef::TensorInterpolation(int fe_stokes){/*{{{*/
 	/*This routine returns the values of the nodal functions  at the gaussian point.*/
 
-	switch(this->element_type){
+	switch(fe_stokes){
 		case XTaylorHoodEnum: return P1DGEnum;
-		default: _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+		default: _error_("Element type "<<EnumToStringx(fe_stokes)<<" not supported yet");
 	}
 }
@@ -527,5 +525,5 @@
 			break;
 		default:
-			_error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+			_error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
 	}
 
Index: issm/trunk/src/c/classes/Elements/TriaRef.h
===================================================================
--- issm/trunk/src/c/classes/Elements/TriaRef.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/TriaRef.h	(revision 18301)
@@ -12,13 +12,6 @@
 
 	public: 
-		int* element_type_list; //P1CG, P1DG, MINI, P2...
-		int  element_type;
-
 		TriaRef();
-		TriaRef(const int nummodels);
 		~TriaRef();
-
-		/*Management*/
-		void SetElementType(int type,int type_counter);
 
 		/*Numerics*/
@@ -27,23 +20,18 @@
 		void GetJacobianDeterminant(IssmDouble* Jdet, IssmDouble* xyz_list,Gauss* gauss);
 		void GetJacobianInvert(IssmDouble*  Jinv, IssmDouble* xyz_list,Gauss* gauss);
-		void GetNodalFunctions(IssmDouble* basis,Gauss* gauss);
 		void GetNodalFunctions(IssmDouble* basis,Gauss* gauss,int finiteelement);
-		void GetSegmentNodalFunctions(IssmDouble* basis,Gauss* gauss, int index1,int index2);
-		void GetSegmentBFlux(IssmDouble* B,Gauss* gauss, int index1,int index2);
-		void GetSegmentBprimeFlux(IssmDouble* Bprime,Gauss* gauss, int index1,int index2);
-		void GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, Gauss* gauss);
+		void GetSegmentNodalFunctions(IssmDouble* basis,Gauss* gauss, int index1,int index2,int finiteelement);
+		void GetSegmentBFlux(IssmDouble* B,Gauss* gauss, int index1,int index2,int finiteelement);
+		void GetSegmentBprimeFlux(IssmDouble* Bprime,Gauss* gauss, int index1,int index2,int finiteelement);
 		void GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, Gauss* gauss,int finiteelement);
-		void GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,Gauss* gauss);
 		void GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,Gauss* gauss,int finiteelement);
-		void GetInputValue(IssmDouble* pp, IssmDouble* plist, Gauss* gauss);
 		void GetInputValue(IssmDouble* pp, IssmDouble* plist, Gauss* gauss,int finiteelement);
-		void GetInputDerivativeValue(IssmDouble* pp, IssmDouble* plist,IssmDouble* xyz_list, Gauss* gauss);
+		void GetInputDerivativeValue(IssmDouble* pp, IssmDouble* plist,IssmDouble* xyz_list, Gauss* gauss,int finiteelement);
 
 		void NodeOnEdgeIndices(int* pnumindices,int** pindices,int index,int finiteelement);
-		int  NumberofNodes(void);
 		int  NumberofNodes(int finiteelement);
-		int  VelocityInterpolation(void);
-		int  PressureInterpolation(void);
-		int  TensorInterpolation(void);
+		int  VelocityInterpolation(int fe_stokes);
+		int  PressureInterpolation(int fe_stokes);
+		int  TensorInterpolation(int fe_stokes);
 };
 #endif
Index: issm/trunk/src/c/classes/ExternalResults/Results.cpp
===================================================================
--- issm/trunk/src/c/classes/ExternalResults/Results.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/ExternalResults/Results.cpp	(revision 18301)
@@ -20,12 +20,10 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Results::Results(){{{*/
-Results::Results(){
+Results::Results(){/*{{{*/
 	enum_type=ResultsEnum;
 	return;
 }
 /*}}}*/
-/*FUNCTION Results::~Results(){{{*/
-Results::~Results(){
+Results::~Results(){/*{{{*/
 	return;
 }
@@ -33,6 +31,5 @@
 
 /*Object management*/
-/*FUNCTION Results::Write{{{*/
-void Results::Write(Parameters* parameters){
+void Results::Write(Parameters* parameters){/*{{{*/
 
 	FILE       *fid  = NULL;
@@ -50,6 +47,5 @@
 }
 /*}}}*/
-/*FUNCTION Results::AddResult(ExternalResult* in_result){{{*/
-int Results::AddResult(ExternalResult* in_result){
+int Results::AddResult(ExternalResult* in_result){/*{{{*/
 
 	/*First, go through dataset of inputs and check whether any input 
@@ -82,6 +78,5 @@
 }
 /*}}}*/
-/*FUNCTION Results::DeleteResult(ExternalResult* in_result){{{*/
-int Results::DeleteResult(int result_enum,int result_step){
+int Results::DeleteResult(int result_enum,int result_step){/*{{{*/
 
 	for(int i=0;i<this->Size();i++){
